Newer
Older
Fabrice Bellard
committed
#
# Copyright (c) 2000-2002 Fabrice Bellard
# Copyright (c) 2005-2008 Diego Biurrun
# Copyright (c) 2005-2008 Mans Rullgard
Fabrice Bellard
committed
#
# Prevent locale nonsense from breaking basic text processing.
LC_ALL=C
export LC_ALL
# make sure we are running under a compatible shell
# try to make this part work with most shells
try_exec(){
type "$1" > /dev/null 2>&1 && exec "$@"
(: ${foo%%bar}) 2> /dev/null
(: ${foo?}) 2> /dev/null
E2="$?"
if test "$E1" != 0 || test "$E2" = 0; then
echo "Broken shell detected. Trying alternatives."
export FF_CONF_EXEC
if test "0$FF_CONF_EXEC" -lt 1; then
FF_CONF_EXEC=1
try_exec bash "$0" "$@"
fi
if test "0$FF_CONF_EXEC" -lt 2; then
FF_CONF_EXEC=2
try_exec ksh "$0" "$@"
fi
if test "0$FF_CONF_EXEC" -lt 3; then
FF_CONF_EXEC=3
try_exec /usr/xpg4/bin/sh "$0" "$@"
fi
echo "No compatible shell script interpreter found."
echo "such as bash or ksh."
echo "THIS IS NOT A BUG IN FFMPEG, DO NOT REPORT IT AS SUCH."
echo "Instead, install a working POSIX-compatible shell."
echo "Disabling this configure test will create a broken FFmpeg."
if test "$BASH_VERSION" = '2.04.0(1)-release'; then
echo "This bash version ($BASH_VERSION) is broken on your platform."
echo "Upgrade to a later version if available."
fi
exit 1
fi
show_help(){
echo "Usage: configure [options]"
echo "Options: [defaults in brackets after descriptions]"
echo
echo "Standard options:"
echo " --help print this message"
echo " --logfile=FILE log tests and output to FILE [config.err]"
echo " --disable-logging do not log configure debug information"
echo " --prefix=PREFIX install in PREFIX [$prefix]"
echo " --bindir=DIR install binaries in DIR [PREFIX/bin]"
echo " --datadir=DIR install data files in DIR [PREFIX/share/ffmpeg]"
echo " --libdir=DIR install libs in DIR [PREFIX/lib]"
Diego Biurrun
committed
echo " --shlibdir=DIR install shared libs in DIR [PREFIX/lib]"
echo " --incdir=DIR install includes in DIR [PREFIX/include]"
echo " --mandir=DIR install man page in DIR [PREFIX/share/man]"
echo
echo "Configuration options:"
echo " --disable-static do not build static libraries [no]"
echo " --enable-shared build shared libraries [no]"
echo " --enable-gpl allow use of GPL code, the resulting libs"
echo " and binaries will be under GPL [no]"
echo " --enable-nonfree allow use of nonfree code, the resulting libs"
echo " and binaries will be unredistributable [no]"
echo " --disable-ffmpeg disable ffmpeg build"
echo " --disable-ffplay disable ffplay build"
echo " --disable-ffserver disable ffserver build"
echo " --enable-postproc enable GPLed postprocessing support [no]"
echo " --enable-swscale enable GPLed software scaler support [no]"
echo " --enable-avfilter video filter support (replaces vhook) [no]"
echo " --enable-avfilter-lavf video filters dependent on avformat [no]"
Diego Biurrun
committed
echo " --disable-vhook disable video hooking support"
echo " --enable-beosthreads use BeOS threads [no]"
echo " --enable-os2threads use OS/2 threads [no]"
echo " --enable-pthreads use pthreads [no]"
echo " --enable-w32threads use Win32 threads [no]"
echo " --enable-x11grab enable X11 grabbing [no]"
echo " --enable-xvmc enable XvMC support [no]"
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
echo " --disable-network disable network support [no]"
echo " --disable-ipv6 disable IPv6 support [no]"
echo " --disable-mpegaudio-hp faster (but less accurate) MPEG audio decoding [no]"
echo " --enable-gray enable full grayscale support (slower color)"
echo " --disable-fastdiv disable table-based division"
echo " --enable-small optimize for size instead of speed"
echo " --disable-aandct disable AAN DCT code"
echo " --disable-fft disable FFT code"
echo " --disable-golomb disable Golomb code"
echo " --disable-mdct disable MDCT code"
echo " --enable-hardcoded-tables use hardcoded tables instead of runtime generation"
echo " --enable-memalign-hack emulate memalign, interferes with memory debuggers"
echo " --enable-beos-netserver enable BeOS netserver"
echo " --disable-encoder=NAME disable encoder NAME"
echo " --enable-encoder=NAME enable encoder NAME"
echo " --disable-encoders disable all encoders"
echo " --disable-decoder=NAME disable decoder NAME"
echo " --enable-decoder=NAME enable decoder NAME"
echo " --disable-decoders disable all decoders"
echo " --disable-muxer=NAME disable muxer NAME"
echo " --enable-muxer=NAME enable muxer NAME"
echo " --disable-muxers disable all muxers"
echo " --disable-demuxer=NAME disable demuxer NAME"
echo " --enable-demuxer=NAME enable demuxer NAME"
echo " --disable-demuxers disable all demuxers"
echo " --enable-parser=NAME enable parser NAME"
echo " --disable-parser=NAME disable parser NAME"
echo " --disable-parsers disable all parsers"
echo " --enable-bsf=NAME enable bitstream filter NAME"
echo " --disable-bsf=NAME disable bitstream filter NAME"
echo " --disable-bsfs disable all bitstream filters"
echo " --enable-protocol=NAME enable protocol NAME"
echo " --disable-protocol=NAME disable protocol NAME"
echo " --disable-protocols disable all protocols"
echo " --disable-indevs disable input devices"
echo " --disable-outdevs disable output devices"
echo " --disable-devices disable all devices"
echo " --enable-filter=NAME enable filter NAME"
echo " --disable-filter=NAME disable filter NAME"
echo " --disable-filters disable all filters"
echo " --list-decoders show all available decoders"
echo " --list-encoders show all available encoders"
echo " --list-muxers show all available muxers"
echo " --list-demuxers show all available demuxers"
echo " --list-parsers show all available parsers"
echo " --list-protocols show all available protocols"
echo " --list-bsfs show all available bitstream filters"
echo " --list-indevs show all available input devices"
echo " --list-outdevs show all available output devices"
echo " --list-filters show all available filters"
echo
echo "External library support:"
echo " --enable-avisynth enable reading of AVISynth script files [no]"
echo " --enable-bzlib enable bzlib [autodetect]"
echo " --enable-libamr-nb enable libamr-nb floating point audio codec [no]"
echo " --enable-libamr-wb enable libamr-wb floating point audio codec [no]"
echo " --enable-libdc1394 enable IIDC-1394 grabbing using libdc1394"
echo " and libraw1394 [no]"
echo " --enable-libdirac enable Dirac support via libdirac [no]"
echo " --enable-libfaac enable FAAC support via libfaac [no]"
echo " --enable-libfaad enable FAAD support via libfaad [no]"
echo " --enable-libfaadbin open libfaad.so.0 at runtime [no]"
echo " --enable-libgsm enable GSM support via libgsm [no]"
echo " --enable-libmp3lame enable MP3 encoding via libmp3lame [no]"
echo " --enable-libnut enable NUT (de)muxing via libnut,"
echo " native (de)muxer exists [no]"
echo " --enable-libschroedinger enable Dirac support via libschroedinger [no]"
echo " --enable-libspeex enable Speex decoding via libspeex [no]"
echo " --enable-libtheora enable Theora encoding via libtheora [no]"
echo " --enable-libvorbis enable Vorbis encoding via libvorbis,"
echo " native implementation exists [no]"
echo " --enable-libx264 enable H.264 encoding via x264 [no]"
Diego Biurrun
committed
echo " --enable-libxvid enable Xvid encoding via xvidcore,"
echo " native MPEG-4/Xvid encoder exists [no]"
echo " --enable-zlib enable zlib [autodetect]"
echo ""
echo "Advanced options (experts only):"
echo " --source-path=PATH path to source code [$source_path]"
echo " --cross-prefix=PREFIX use PREFIX for compilation tools [$cross_prefix]"
echo " --enable-cross-compile assume a cross-compiler is used"
echo " --target-os=OS compiler targets OS [$target_os]"
echo " --target-exec=CMD command to run executables on target"
echo " --target-path=DIR path to view of build directory on target"
echo " --nm=NM use nm tool"
echo " --cc=CC use C compiler CC [$cc_default]"
echo " --host-cc=HOSTCC use host C compiler HOSTCC"
echo " --host-cflags=HCFLAGS use HCFLAGS when compiling for host"
echo " --host-ldflags=HLDFLAGS use HLDFLAGS when linking for host"
echo " --host-libs=HLIBS use libs HLIBS when linking for host"
echo " --extra-cflags=ECFLAGS add ECFLAGS to CFLAGS [$CFLAGS]"
echo " --extra-ldflags=ELDFLAGS add ELDFLAGS to LDFLAGS [$LDFLAGS]"
echo " --extra-libs=ELIBS add ELIBS [$ELIBS]"
echo " --extra-version=STRING version string suffix []"
echo " --build-suffix=SUFFIX library name suffix []"
echo " --arch=ARCH select architecture [$arch]"
echo " --cpu=CPU select the minimum required CPU (affects"
echo " instruction selection, may crash on older CPUs)"
echo " --enable-powerpc-perf enable performance report on PPC"
echo " (requires enabling PMC)"
Diego Biurrun
committed
echo " --disable-altivec disable AltiVec optimizations"
echo " --disable-amd3dnow disable 3DNow! optimizations"
echo " --disable-mmx disable MMX optimizations"
echo " --disable-mmx2 disable MMX2 optimizations"
echo " --disable-sse disable SSE optimizations"
echo " --disable-ssse3 disable SSSE3 optimizations"
echo " --disable-armv5te disable armv5te optimizations"
echo " --disable-armv6 disable armv6 optimizations"
echo " --disable-armv6t2 disable armv6t2 optimizations"
echo " --disable-armvfp disable ARM VFP optimizations"
echo " --disable-iwmmxt disable iwmmxt optimizations"
echo " --disable-mmi disable MMI optimizations"
echo " --disable-neon disable neon optimizations"
echo " --disable-vis disable VIS optimizations"
echo
echo "Developer options (useful when working on FFmpeg itself):"
echo " --disable-debug disable debugging symbols"
echo " --enable-debug=LEVEL set the debug level [$debuglevel]"
echo " --enable-gprof enable profiling with gprof [$gprof]"
echo " --disable-optimizations disable compiler optimizations"
echo " --enable-extra-warnings enable more compiler warnings"
echo " --disable-stripping disable stripping of executables and shared libraries"
echo ""
echo "NOTE: Object files are built at the place where configure is launched."
log(){
echo "$@" >> $logfile
}
log_file(){
pr -n -t $1 >> $logfile
echolog(){
echo "$@"
}
die(){
echolog "$@"
cat <<EOF
If you think configure made a mistake, make sure you are using the latest
version from SVN. If the latest version fails, report the problem to the
ffmpeg-user@mplayerhq.hu mailing list or IRC #ffmpeg on irc.freenode.net.
EOF
if disabled logging; then
cat <<EOF
Rerun configure with logging enabled (do not use --disable-logging), and
include the log this produces with your report.
EOF
else
cat <<EOF
Include the log file "$logfile" produced by configure as this will help
solving the problem.
EOF
fi
rm -f $TMPC $TMPE $TMPH $TMPO $TMPS $TMPSH
exit 1
}
# Avoid locale weirdness, besides we really just want to translate ASCII.
echo "$@" | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ
echo "$@" | tr ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz
c_escape(){
echo "$*" | sed 's/["\\]/\\\0/g'
}
set_all(){
value=$1
shift
for var in $*; do
eval $var=$value
done
}
set_weak(){
value=$1
shift
for var; do
eval : \${$var:=$value}
done
}
pushvar(){
for var in $*; do
eval level=\${${var}_level:=0}
eval ${var}_${level}="\$$var"
eval ${var}_level=$(($level+1))
done
}
popvar(){
for var in $*; do
eval level=\${${var}_level:-0}
test $level = 0 && continue
eval level=$(($level-1))
eval $var="\${${var}_${level}}"
eval ${var}_level=$level
eval unset ${var}_${level}
done
}
enable(){
set_all yes $*
}
disable(){
set_all no $*
}
enable_weak(){
set_weak yes $*
}
disable_weak(){
set_weak no $*
}
do_enable_deep(){
for var; do
enabled $var && continue
eval sel="\$${var}_select"
eval sgs="\$${var}_suggest"
pushvar var sgs
popvar sgs
enable_deep_weak $sgs
popvar var
done
}
enable_deep(){
do_enable_deep $*
enable $*
}
enable_deep_weak(){
do_enable_deep $*
enable_weak $*
}
enabled(){
test "${1#!}" = "$1" && op== || op=!=
eval test "x\$${1#!}" $op "xyes"
test "${1#!}" = "$1" && op== || op=!=
eval test "x\$${1#!}" $op "xno"
enabled_all(){
for opt; do
enabled $opt || return 1
done
}
disabled_all(){
for opt; do
disabled $opt || return 1
done
}
enabled_any(){
for opt; do
enabled $opt && return 0
done
}
disabled_any(){
for opt; do
disabled $opt && return 0
done
eval : \${$opt:=\$${opt}_default}
is_in(){
value=$1
shift
for var in $*; do
[ $var = $value ] && return 0
done
return 1
}
check_deps(){
for cfg; do
cfg="${cfg#!}"
enabled ${cfg}_checking && die "Circular dependency for $cfg."
disabled ${cfg}_checking && continue
enable ${cfg}_checking
eval dep_all="\$${cfg}_deps"
eval dep_any="\$${cfg}_deps_any"
pushvar cfg dep_all dep_any dep_sel dep_sgs
check_deps $dep_all $dep_any $dep_sel $dep_sgs
popvar cfg dep_all dep_any dep_sel dep_sgs
enabled_all $dep_all || disable $cfg
enabled_any $dep_any || disable $cfg
disabled_any $dep_sel && disable $cfg
if enabled $cfg; then
eval dep_extralibs="\$${cfg}_extralibs"
test -n "$dep_extralibs" && add_extralibs $dep_extralibs
print_config(){
pfx=$1
header=$2
makefile=$3
shift 3
for cfg; do
ucname="`toupper $cfg`"
echo "#define ${pfx}${ucname} 1" >> $header
echo "${pfx}${ucname}=yes" >> $makefile
else
echo "#define ${pfx}${ucname} 0" >> $header
}
flags_saved(){
(: ${SAVE_CFLAGS?}) 2> /dev/null
}
flags_saved && return
SAVE_CFLAGS="$CFLAGS"
SAVE_LDFLAGS="$LDFLAGS"
SAVE_extralibs="$extralibs"
}
restore_flags(){
flags_saved || return
CFLAGS="$SAVE_CFLAGS"
LDFLAGS="$SAVE_LDFLAGS"
extralibs="$SAVE_extralibs"
unset SAVE_CFLAGS
unset SAVE_LDFLAGS
unset SAVE_extralibs
}
temp_cflags(){
save_flags
CFLAGS="$CFLAGS $*"
}
temp_ldflags(){
save_flags
LDFLAGS="$LDFLAGS $*"
}
temp_extralibs(){
save_flags
extralibs="$extralibs $*"
}
append(){
var=$1
shift
flags_saved && eval "SAVE_$var=\"\$SAVE_$var $*\""
eval "$var=\"\$$var $*\""
}
add_cflags(){
append CFLAGS "$@"
}
add_ldflags(){
append LDFLAGS "$@"
}
add_extralibs(){
append extralibs "$@"
}
check_cmd(){
"$@" >> $logfile 2>&1
log check_cc "$@"
log_file $TMPC
check_cmd $cc $CFLAGS "$@" -c -o $TMPO $TMPC
}
check_cpp(){
log check_cpp "$@"
log_file $TMPC
check_cmd $cc $CFLAGS "$@" -E -o $TMPO $TMPC
check_asm(){
log check_asm "$@"
name="$1"
asm="$2"
shift 2
check_cc "$@" <<EOF && enable $name || disable $name
void foo(void){ __asm__ volatile($asm); }
check_yasm(){
log check_yasm "$@"
echo "$1" > $TMPS
log_file $TMPS
shift 1
check_cmd $yasmexe $YASMFLAGS "$@" -o $TMPO $TMPS
}
log check_ld "$@"
flags=''
libs=''
for f; do
test "${f}" = "${f#-l}" && flags="$flags $f" || libs="$libs $f"
done
check_cmd $cc $LDFLAGS $flags -o $TMPE $TMPO $extralibs $libs
log check_cflags "$@"
check_cc "$@" <<EOF && add_cflags "$@"
int x;
EOF
}
check_ldflags(){
log check_ldflags "$@"
check_ld "$@" <<EOF && add_ldflags "$@"
int main(void){ return 0; }
EOF
}
check_header(){
log check_header "$@"
var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
disable $var
check_cpp "$@" <<EOF && enable $var
#include <$header>
int x;
EOF
}
check_func(){
log check_func "$@"
int main(void){ $func(); }
check_func_headers(){
log check_func_headers "$@"
headers=$1
func=$2
shift 2
disable $func
incs=""
for hdr in $headers; do
incs="$incs
#include <$hdr>"
done
check_ld "$@" <<EOF && enable $func
$incs
int main(int argc, char **argv){
(void) $func;
return 0;
}
EOF
}
check_cpp_condition(){
log check_cpp_condition "$@"
header=$1
condition=$2
check_cpp <<EOF
#include <$header>
#if !($condition)
#error "unsatisfied condition: $condition"
#endif
EOF
}
check_lib(){
log check_lib "$@"
header="$1"
func="$2"
shift 2
temp_extralibs "$@"
check_header $header && check_func $func && add_extralibs "$@"
err=$?
restore_flags
return $err
}
check_lib2(){
log check_lib2 "$@"
headers="$1"
func="$2"
shift 2
temp_extralibs "$@"
check_func_headers "$headers" $func && add_extralibs "$@"
err=$?
restore_flags
return $err
}
check_ld "$@" && { enabled cross_compile || $TMPE >> $logfile 2>&1; }
}
check_exec_crash(){
code=`cat`
# exit() is not async signal safe. _Exit (C99) and _exit (POSIX)
# are safe but may not be available everywhere. Thus we use
# raise(SIGTERM) instead. The check is run in a subshell so we
# can redirect the "Terminated" message from the shell. SIGBUS
# is not defined by standard C so it is used conditionally.
(check_exec "$@") >> $logfile 2>&1 <<EOF
#include <signal.h>
static void sighandler(int sig){
raise(SIGTERM);
}
signal(SIGILL, sighandler);
signal(SIGFPE, sighandler);
signal(SIGSEGV, sighandler);
#ifdef SIGBUS
signal(SIGBUS, sighandler);
#endif
{ $code }
}
EOF
}
check_type(){
log check_type "$@"
headers=$1
type=$2
shift 2
disable $type
incs=""
for hdr in $headers; do
incs="$incs
#include <$hdr>"
done
check_cc "$@" <<EOF && enable $type
$incs
$type v;
EOF
}
require(){
name="$1"
header="$2"
func="$3"
shift 3
check_lib $header $func "$@" || die "ERROR: $name not found"
require2(){
name="$1"
headers="$2"
func="$3"
shift 3
check_lib2 "$headers" $func "$@" || die "ERROR: $name not found"
}
check_foo_config(){
cfg=$1
pkg=$2
header=$3
func=$4
shift 4
disable $cfg
check_cmd ${pkg}-config --version
err=$?
if test "$err" = 0; then
temp_cflags `${pkg}-config --cflags`
temp_extralibs `${pkg}-config --libs`
check_lib "$@" $header $func && enable $cfg
fi
return $err
}
apply(){
file=$1
shift
"$@" < "$file" > "$file.tmp" && mv "$file.tmp" "$file" || rm "$file.tmp"
}
Diego Biurrun
committed
# CONFIG_LIST contains configurable options, while HAVE_LIST is for
# system-dependent things.
COMPONENT_LIST="
bsfs
decoders
demuxers
encoders
parsers
protocols
"
CONFIG_LIST="
$COMPONENT_LIST
Vitor Sessak
committed
avfilter
avfilter_lavf
avisynth
beos_netserver
ffmpeg
ffplay
ffserver
libamr_nb
libamr_wb
Diego Biurrun
committed
libfaac
libfaad
libfaadbin
Diego Biurrun
committed
libx264
libxvid
mpegaudio_hp
network
nonfree
powerpc_perf
swscale
THREADS_LIST='
beosthreads
pthreads
w32threads
'
ARCH_LIST='
alpha
bfin
ia64
m68k
mips
parisc
s390
sh4
sparc
sparc64
x86
x86_32
x86_64
'
ARCH_EXT_LIST='
amd3dnow
iwmmxt
mmi
mmx
Diego Biurrun
committed
ppc4xx
'
HAVE_LIST="
$ARCH_EXT_LIST
$THREADS_LIST
altivec_h
François Revol
committed
arpa_inet_h
dev_bktr_ioctl_bt848_h
dev_bktr_ioctl_meteor_h
dev_ic_bt8xx_h
dev_video_meteor_ioctl_meteor_h
dev_video_bktr_ioctl_bt848_h
dos_paths
ebp_available
ebx_available
GetProcessTimes
Alessandro Sappia
committed
libdc1394_1
libdc1394_2
llrint
lrint
machine_ioctl_bt848_h
machine_ioctl_meteor_h
malloc_h
memalign
Matthieu Castet
committed
pld
round
roundf
sdl
sdl_video_size
sys_select_h
"
# options emitted with CONFIG_ prefix but not available on command line
CONFIG_EXTRA="
fft_mmx
oldscaler
$ARCH_EXT_LIST
$THREADS_LIST
logging
optimizations
stripping
PATHS_LIST='
incdir
libdir
mandir
prefix
shlibdir
'
CMDLINE_SET="
$PATHS_LIST
arch
build_suffix
cc
cpu
cross_prefix
extra_version
host_cc
host_cflags
host_ldflags
host_libs
altivec_deps="ppc"
amd3dnow_deps="mmx"
armv5te_deps="arm"
armv6_deps="arm"
armvfp_deps="arm"
iwmmxt_deps="arm"
Diego Biurrun
committed
mmi_deps="mips"
Diego Biurrun
committed
ppc4xx_deps="ppc"
sse_deps="mmx"
ssse3_deps="sse"
# common features
fft_suggest="fft_mmx"
fft_mmx_deps="mmx yasm"
oldscaler_deps="!swscale"
ac3_decoder_select="fft mdct"
atrac3_decoder_select="fft mdct"
cavs_decoder_select="golomb"
dnxhd_encoder_select="aandct"
Justin Ruggles
committed
eac3_decoder_deps="gpl"
eatgq_decoder_select="aandct"
ffv1_decoder_select="golomb"
flac_decoder_select="golomb"
flac_encoder_select="golomb"
flashsv_decoder_select="zlib"
flashsv_encoder_select="zlib"
flv_encoder_select="aandct"
h261_encoder_select="aandct"
h263_encoder_select="aandct"
h263p_encoder_select="aandct"
h264_decoder_select="golomb"
h264_vdpau_decoder_deps="vdpau"
jpegls_decoder_select="golomb"